## ros-noetic-fuse-loss 0.4.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(fuse_loss)

set(build_depends
  fuse_core
  pluginlib
  roscpp
)

find_package(catkin REQUIRED COMPONENTS
  ${build_depends}
)

find_package(Ceres REQUIRED)

catkin_package(
  INCLUDE_DIRS
    include
  LIBRARIES
    ${PROJECT_NAME}
  CATKIN_DEPENDS
    ${build_depends}
  DEPENDS
    CERES
)

###########
## Build ##
###########

add_compile_options(-Wall -Werror)

add_library(${PROJECT_NAME}
  src/arctan_loss.cpp
  src/cauchy_loss.cpp
  src/composed_loss.cpp
  src/dcs_loss.cpp
  src/fair_loss.cpp
  src/geman_mcclure_loss.cpp
  src/huber_loss.cpp
  src/loss_function.cpp
  src/scaled_loss.cpp
  src/softlone_loss.cpp
  src/tolerant_loss.cpp
  src/trivial_loss.cpp
  src/tukey_loss.cpp
  src/welsch_loss.cpp
)
target_include_directories(${PROJECT_NAME}
  PUBLIC
    include
    ${catkin_INCLUDE_DIRS}
    ${CERES_INCLUDE_DIRS}
)
target_link_libraries(${PROJECT_NAME}
  ${catkin_LIBRARIES}
  ${CERES_LIBRARIES}
)
set_target_properties(${PROJECT_NAME}
  PROPERTIES
    CXX_STANDARD 14
    CXX_STANDARD_REQUIRED YES
)

#############
## Install ##
#############

install(
  TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION}
)

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)

install(
  FILES fuse_plugins.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

#############
## Testing ##
#############

if(CATKIN_ENABLE_TESTING)
  find_package(roslint REQUIRED)

  find_package(Qt5 REQUIRED COMPONENTS
    Core
    Widgets)

  # Find Qwt using FindQwt.cmake copied from:
  # https://gitlab.kitware.com/cmake/community/-/wikis/contrib/modules/FindQwt
  list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
  find_package(Qwt REQUIRED)

  # Lint tests
  set(ROSLINT_CPP_OPTS "--filter=-build/c++11,-runtime/references")
  roslint_cpp()
  roslint_add_test()

  # Loss function Tests
  catkin_add_gtest(test_loss_function
    test/test_loss_function.cpp
  )
  add_dependencies(test_loss_function
    ${catkin_EXPORTED_TARGETS}
  )
  target_include_directories(test_loss_function
    PRIVATE
      include
      ${catkin_INCLUDE_DIRS}
      ${CERES_INCLUDE_DIRS}
  )
  target_link_libraries(test_loss_function
    ${PROJECT_NAME}
    ${catkin_LIBRARIES}
    ${CERES_LIBRARIES}
  )
  set_target_properties(test_loss_function
    PROPERTIES
      CXX_STANDARD 14
      CXX_STANDARD_REQUIRED YES
  )

  # Composed Loss Tests
  catkin_add_gtest(test_composed_loss
    test/test_composed_loss.cpp
  )
  add_dependencies(test_composed_loss
    ${catkin_EXPORTED_TARGETS}
  )
  target_include_directories(test_composed_loss
    PRIVATE
      include
      ${catkin_INCLUDE_DIRS}
      ${CERES_INCLUDE_DIRS}
  )
  target_link_libraries(test_composed_loss
    ${PROJECT_NAME}
    ${catkin_LIBRARIES}
    ${CERES_LIBRARIES}
  )
  set_target_properties(test_composed_loss
    PROPERTIES
      CXX_STANDARD 14
      CXX_STANDARD_REQUIRED YES
  )

  # Huber Loss Tests
  catkin_add_gtest(test_huber_loss
    test/test_huber_loss.cpp
  )
  add_dependencies(test_huber_loss
    ${catkin_EXPORTED_TARGETS}
  )
  target_include_directories(test_huber_loss
    PRIVATE
      include
      ${catkin_INCLUDE_DIRS}
      ${CERES_INCLUDE_DIRS}
  )
  target_link_libraries(test_huber_loss
    ${PROJECT_NAME}
    ${catkin_LIBRARIES}
    ${CERES_LIBRARIES}
  )
  set_target_properties(test_huber_loss
    PROPERTIES
      CXX_STANDARD 14
      CXX_STANDARD_REQUIRED YES
  )

  # Tukey Loss Tests
  catkin_add_gtest(test_tukey_loss
    test/test_tukey_loss.cpp
  )
  add_dependencies(test_tukey_loss
    ${catkin_EXPORTED_TARGETS}
  )
  target_include_directories(test_tukey_loss
    PRIVATE
      include
      ${catkin_INCLUDE_DIRS}
      ${CERES_INCLUDE_DIRS}
  )
  target_link_libraries(test_tukey_loss
    ${PROJECT_NAME}
    ${catkin_LIBRARIES}
    ${CERES_LIBRARIES}
  )
  set_target_properties(test_tukey_loss
    PROPERTIES
      CXX_STANDARD 14
      CXX_STANDARD_REQUIRED YES
  )

  # Qwt Loss Plot Tests
  option(BUILD_WITH_PLOT_TESTS "Build with plot tests. These test might fail to run in headless systems." OFF)
  if(BUILD_WITH_PLOT_TESTS)
    catkin_add_gtest(test_qwt_loss_plot
      test/test_qwt_loss_plot.cpp
    )
    add_dependencies(test_qwt_loss_plot
      ${catkin_EXPORTED_TARGETS}
    )
    target_include_directories(test_qwt_loss_plot
      PRIVATE
        include
        ${catkin_INCLUDE_DIRS}
        ${CERES_INCLUDE_DIRS}
        ${Qt5Core_INCLUDE_DIRS}
        ${Qt5Widgets_INCLUDE_DIRS}
        ${QWT_INCLUDE_DIRS}
    )
    target_link_libraries(test_qwt_loss_plot
      ${PROJECT_NAME}
      ${catkin_LIBRARIES}
      ${CERES_LIBRARIES}
      ${Qt5Core_LIBRARIES}
      ${Qt5Widgets_LIBRARIES}
      ${QWT_LIBRARIES}
    )
    set_target_properties(test_qwt_loss_plot
      PROPERTIES
        CXX_STANDARD 14
        CXX_STANDARD_REQUIRED YES
    )

    option(BUILD_WITH_INTERACTIVE_TESTS "Build with interactive tests" OFF)
    if(BUILD_WITH_INTERACTIVE_TESTS)
      target_compile_definitions(test_qwt_loss_plot PUBLIC INTERACTIVE_TESTS)
    endif(BUILD_WITH_INTERACTIVE_TESTS)
  endif(BUILD_WITH_PLOT_TESTS)

  # Scaled Loss Tests
  catkin_add_gtest(test_scaled_loss
    test/test_scaled_loss.cpp
  )
  add_dependencies(test_scaled_loss
    ${catkin_EXPORTED_TARGETS}
  )
  target_include_directories(test_scaled_loss
    PRIVATE
      include
      ${catkin_INCLUDE_DIRS}
      ${CERES_INCLUDE_DIRS}
  )
  target_link_libraries(test_scaled_loss
    ${PROJECT_NAME}
    ${catkin_LIBRARIES}
    ${CERES_LIBRARIES}
  )
  set_target_properties(test_scaled_loss
    PROPERTIES
      CXX_STANDARD 14
      CXX_STANDARD_REQUIRED YES
  )
endif()

=== debian/changelog ===
ros-noetic-fuse-loss (0.4.2-1buster) buster; urgency=high

  * Adding roslint dependency to fuse_viz (#231 <https://github.com/locusrobotics/fuse/issues/231>)
    * Adding roslint dependency to fuse_viz
    * Silence CMP0048 warnings
  * Contributors: Tom Moore

 -- Stephen Williams <swilliams@locusrobotics.com>  Mon, 19 Jul 2021 23:00:00 -0000

ros-noetic-fuse-loss (0.4.1-1buster) buster; urgency=high

  * Changelogs
  * Fix roslint 0.12.0 (#186 <https://github.com/locusrobotics/fuse/issues/186>)
    * Fix roslint 0.12.0 include_what_you_use warnings
    Mostly for:
    * std::move -> #include <utility>
    * std::make_shared and similar -> #include <memory>
    * Remove static string variable not permitted by roslint 0.12.0, using a test fixture where needed.
  * Replace ignition_sensors list param with ignition field (#163 <https://github.com/locusrobotics/fuse/issues/163>)
    * Remove ignition_sensors param and use a per-sensor ignition field
  * Add ComposedLoss (#170 <https://github.com/locusrobotics/fuse/issues/170>)
  * Patch Tukey loss for Ceres < 2.0.0 (#159 <https://github.com/locusrobotics/fuse/issues/159>)
    * Patch Tukey loss for Ceres < 2.0.0
    * Create ceres_macros.h header
  * Plot loss (#143 <https://github.com/locusrobotics/fuse/issues/143>)
    * Add test to plot loss rho, influence and weight
    * Add BUILD_WITH_PLOT_TESTS option (defaults OFF)
  * Remove Pseudo-Huber loss, it duplicates SoftLOne (#152 <https://github.com/locusrobotics/fuse/issues/152>)
    * Remove Pseudo-Huber loss, it duplicates SoftLOne
  * Add new loss functions (#142 <https://github.com/locusrobotics/fuse/issues/142>)
    The following loss functions, not available in Ceres solver are
    provided:
    * Geman-McClure
    * DCS (Dynamic Covariance Scaling)
    * Fair
    * Pseudo-Huber
    * Welsch
  * Support ScaledLoss (#141 <https://github.com/locusrobotics/fuse/issues/141>)
  * Add fuse_loss pkg with plugin-based loss functions (#118 <https://github.com/locusrobotics/fuse/issues/118>)
  * Contributors: Enrique Fernandez Perdomo, Stephen Williams, Tom Moore
  * Fix roslint 0.12.0 (#186 <https://github.com/locusrobotics/fuse/issues/186>)
    * Fix roslint 0.12.0 include_what_you_use warnings
    Mostly for:
    * std::move -> #include <utility>
    * std::make_shared and similar -> #include <memory>
    * Remove static string variable not permitted by roslint 0.12.0, using a test fixture where needed.
  * Replace ignition_sensors list param with ignition field (#163 <https://github.com/locusrobotics/fuse/issues/163>)
    * Remove ignition_sensors param and use a per-sensor ignition field
  * Add ComposedLoss (#170 <https://github.com/locusrobotics/fuse/issues/170>)
  * Patch Tukey loss for Ceres < 2.0.0 (#159 <https://github.com/locusrobotics/fuse/issues/159>)
    * Patch Tukey loss for Ceres < 2.0.0
    * Create ceres_macros.h header
  * Plot loss (#143 <https://github.com/locusrobotics/fuse/issues/143>)
    * Add test to plot loss rho, influence and weight
    * Add BUILD_WITH_PLOT_TESTS option (defaults OFF)
  * Remove Pseudo-Huber loss, it duplicates SoftLOne (#152 <https://github.com/locusrobotics/fuse/issues/152>)
    * Remove Pseudo-Huber loss, it duplicates SoftLOne
  * Add new loss functions (#142 <https://github.com/locusrobotics/fuse/issues/142>)
    The following loss functions, not available in Ceres solver are
    provided:
    * Geman-McClure
    * DCS (Dynamic Covariance Scaling)
    * Fair
    * Pseudo-Huber
    * Welsch
  * Support ScaledLoss (#141 <https://github.com/locusrobotics/fuse/issues/141>)
  * Add fuse_loss pkg with plugin-based loss functions (#118 <https://github.com/locusrobotics/fuse/issues/118>)
  * Contributors: Enrique Fernandez Perdomo, Stephen Williams

 -- Stephen Williams <swilliams@locusrobotics.com>  Mon, 12 Jul 2021 23:00:00 -0000

ros-noetic-fuse-loss (0.4.0-1buster) buster; urgency=high



 -- Stephen Williams <swilliams@locusrobotics.com>  Thu, 11 Jul 2019 23:00:00 -0000

ros-noetic-fuse-loss (0.3.0-1buster) buster; urgency=high



 -- Stephen Williams <swilliams@locusrobotics.com>  Mon, 18 Mar 2019 00:00:00 -0000

ros-noetic-fuse-loss (0.2.0-1buster) buster; urgency=high



 -- Stephen Williams <swilliams@locusrobotics.com>  Wed, 16 Jan 2019 00:00:00 -0000

ros-noetic-fuse-loss (0.1.1-1buster) buster; urgency=high



 -- Stephen Williams <swilliams@locusrobotics.com>  Tue, 14 Aug 2018 23:00:00 -0000

ros-noetic-fuse-loss (0.1.0-1buster) buster; urgency=high



 -- Stephen Williams <swilliams@locusrobotics.com>  Sat, 11 Aug 2018 23:00:00 -0000

ros-noetic-fuse-loss (0.0.2-1buster) buster; urgency=high



 -- Stephen Williams <swilliams@locusrobotics.com>  Sun, 15 Jul 2018 23:00:00 -0000

ros-noetic-fuse-loss (0.0.1-1buster) buster; urgency=high



 -- Stephen Williams <swilliams@locusrobotics.com>  Wed, 04 Jul 2018 23:00:00 -0000

=== debian/control ===
Source: ros-noetic-fuse-loss
Section: misc
Priority: optional
Maintainer: Stephen Williams <swilliams@locusrobotics.com>
Build-Depends: debhelper (>= 9.0.0), libceres-dev, libqwt-qt5-dev, qtbase5-dev, ros-noetic-catkin, ros-noetic-fuse-core, ros-noetic-pluginlib, ros-noetic-roscpp, ros-noetic-roslint
Homepage: 
Standards-Version: 3.9.2

Package: ros-noetic-fuse-loss
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libceres-dev, ros-noetic-fuse-core, ros-noetic-pluginlib, ros-noetic-roscpp
Description: The fuse_loss package provides a set of commonly used loss functions, such as the basic ones provided by Ceres.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG -O3

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-fuse-loss//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
